package DX::ShellState;

use DX::Class;

has template_query_state => (
  is => 'ro', required => 1, isa => QueryState
);

has current_query_state => (
  is => 'lazy', builder => 'new_query_state'
);

has mode => (is => 'ro', required => 1);

sub new_query_state { $_[0]->template_query_state }

sub with_new_query_state {
  my ($self) = @_;
  $self->but(
    current_query_state => $self->new_query_state
  );
}

sub with_mode {
  my ($self, $new_mode) = @_;
  return (
    $self->but(mode => $new_mode),
    [ mode => $new_mode ],
  );
}

1;
